import { useMemo, useRef } from 'react';
import { useFirestoreCollection } from 'reactfire';
import { useQuerySnapData } from './useSnapData.js';
import { useFirestoreErrorLogger, useSafeRef } from './utils.js';
export const useTypedCollection = (typedRef, selector, dataOptions = {}) => {
    var _a;
    const _typedQuery = (_a = selector === null || selector === void 0 ? void 0 : selector(typedRef.select)) !== null && _a !== void 0 ? _a : typedRef;
    const { safeRef: safeQuery, refChanged } = useSafeRef(_typedQuery.raw);
    const memoizedTypedRef = useRef();
    if (refChanged) {
        memoizedTypedRef.current = typedRef;
    }
    const { data: _snap, error } = useFirestoreCollection(safeQuery, {
        suspense: true,
    });
    useFirestoreErrorLogger(error);
    const { snap, data } = useQuerySnapData(typedRef, _snap, dataOptions);
    return useMemo(() => {
        refChanged;
        return { typedRef: memoizedTypedRef.current, snap, data, error };
    }, [data, error, refChanged, snap]);
};
